<?php

namespace Wp618\Database;

if ( !defined( 'ABSPATH' ) ) exit;

//
class Setup
{
    //
    private $app;

    //
    public function __construct(){
        $this->app = App::getInstance();
    }

    //
    public function load_setup(){
        if($this->app->get_is_actived()){
//            $option = 'general';
//            $data = $this->get_setup_data($option);
//            $this->app->display($option, $data);

            $this->db_show();
        }else{
            $action = get_action('app_active');
            $data = [
                'action' => $action,
                'nonce' => \wp_create_nonce($action),
                'option' => 'none',
            ];

            $this->app->display('active', $data);
        }
    }

    //
    public function db_show(){
        $list = $this->app->visitor_model->get_db()->get_results('show table status', ARRAY_A);

        $prefix = $this->app->visitor_model->get_prefix();

        foreach ($list as &$item){
            $item['notice'] = '';

            if($item['Name'] === ($prefix .'commentmeta')){
                $item['notice'] = '评论元数据';
            }
            if($item['Name'] === ($prefix .'comments')){
                $item['notice'] = '评论';
            }
            if($item['Name'] === ($prefix .'links')){
                $item['notice'] = '友情链接';
            }
            if($item['Name'] === ($prefix .'options')){
                $item['notice'] = '配置';
            }
            if($item['Name'] === ($prefix .'postmeta')){
                $item['notice'] = '文章元数据';
            }
            if($item['Name'] === ($prefix .'posts')){
                $item['notice'] = '文章';
            }
            if($item['Name'] === ($prefix .'term_relationships')){
                $item['notice'] = '分类关系';
            }
            if($item['Name'] === ($prefix .'term_taxonomy')){
                $item['notice'] = '分类法';
            }
            if($item['Name'] === ($prefix .'terms')){
                $item['notice'] = '分类法名称';
            }
            if($item['Name'] === ($prefix .'termmeta')){
                $item['notice'] = '分类法元数据';
            }
            if($item['Name'] === ($prefix .'usermeta')){
                $item['notice'] = '用户元数据';
            }
            if($item['Name'] === ($prefix .'users')){
                $item['notice'] = '用户';
            }
        }
        unset($item);

        $action = get_action('delete_more_log');
        $nonce = \wp_create_nonce($action);

        $this->app->display('log', [
            'list' => $list,
            'action' => $action,
            'nonce' => $nonce,
        ]);
    }

    //
    private function get_setup_data($option){
        $config = get_app_config();
        $set = $this->get_render_items($option, $config);

        $action = get_action('setup_save');

        $data = [
            'action' => $action,
            'nonce' => \wp_create_nonce($action),
            'option' => $option,
            'set' => $set,
        ];

        return $data;
    }

    //
    private function get_render_items($option, $config){
        if(isset($config[$option])){
            return $config[$option];
        }

        $list = [];

        if(isset(Constant::SETUP_FIELDS[$option])){
            foreach (Constant::SETUP_FIELDS[$option] as $name => $val){
                $list[$name] = $val[1];
            }
        }

        return $list;
    }
}